'
' Hardware PWM manipulation procedure demo
'
' For use with PIC24F and PIC24H devices
'
    Device = 24FJ64GA002
    Declare Xtal = 32
    
    Declare Hserial_Baud = 9600
    Declare Hrsout1_Pin = PORTB.14          ' Select which pin is to be used for TX with USART1
    
    Declare CCP1_Pin = PORTB.0
    Declare CCP2_Pin = PORTB.1
    Declare CCP3_Pin = PORTB.2
    Declare CCP4_Pin = PORTB.3     
 
    Include "PWM.inc"                       ' Load the Hardware PWM procedures into the program
    
    Dim MyDuty As Byte
    Dim MyFrequency As Word
          
'---------------------------------------------------------------------------
Main:     
    PPS_Output(cOut_Pin_RP14, cOut_Fn_U1TX) ' Make RP14(RB14) the pin for UART1 TX

    PPS_Output(cOut_Pin_RP0, cOut_Fn_OC1)   ' Make RP0(RB0) the pin for PWM1
    PPS_Output(cOut_Pin_RP1, cOut_Fn_OC2)   ' Make RP1(RB1) the pin for PWM2
'
' Fixed Frequency, Variable Duty Cycle
'        
    HPWM1_SetFreq(1000, 0)                  ' PWM1: 1KHz, 0% duty
    HPWM2_SetFreq(1000, 0)                  ' PWM2: 1KHz, 0% duty
    
    For MyDuty = 0 To 255                   ' Create a loop for the duty cycle
        HPWM1_Duty(MyDuty)                  ' Alter the duty cycle of PWM1
        HPWM2_Duty(MyDuty)                  ' Alter the duty cycle of PWM2
        DelayMS 10                          ' A small delay to see the change more clearly
    Next
'
' Variable Frequency, Fixed Duty Cycle
'
    For MyFrequency = 1 To 65535 Step 64                ' Create a loop for the frequency
        If HPWM1_SetFreq(MyFrequency, 127) = 0 Then     ' Could we acheive the frequency?
            HRSOut "Unable to achieve frequency ", Dec MyFrequency, 13 ' No.
        Else                                            ' Otherwise
            HPWM2_SetFreq(MyFrequency, 127)             ' Alter PWM as well
            HRSOut "Frequency = ", Dec MyFrequency, 13  ' Transmit the frequency we're doing
        EndIf
    Next                                                ' CLose the loop

    
    

